#ifndef COUNTER_H_
#define COUNTER_H_

/**
 * @short indices for for loops
 *
 * The Counter class is used to represent counters in for loops in the
 * BUGS language.
 *
 * The Counter class has much the same functionality as a Left
 * RangeIterator or Right RangeIterator, so could be replaced.
 *
 * <pre>
 * for (i in 1:N) {
 * }
 * </pre>
 */
class Counter {
  long _start, _finish, _value;
public:
  /**
   * Create a counter ranging from start to finish. If start > finish
   * then the arguments are swapped over. The initial value of the
   * counter is start.
   */
  Counter(long start, long finish);
  /** Returns the current value of the counter */
  long value() const;
  /** Increments the value of the counter by 1 */
  void increment();
  /** Resets the counter to its initial value */
  void reset();
  /** Determines whether the counter has reached the end of its range */
  bool atEnd() const;
};

#endif /* COUNTER_H_ */

