#ifndef SAMPLER_FACTORY_H_
#define SAMPLER_FACTORY_H_

//#include <sampler/Sampler.h>
class Sampler;
class StochasticNode;
#include <set>
#include <list>

/**
 * @short Factory object for samplers
 */
class SamplerFactory
{
 public:
  virtual ~SamplerFactory() {};
  /**
   * Finds nodes in the set of stochastic nodes that can be sampled,
   * removes them from the set and adds one or more samplers to the
   * list of samplers.
   */
  virtual void makeSampler(std::set<StochasticNode*> &nodes, 
			   std::list<Sampler*> &samplers) const = 0;
};

#endif /* SAMPLER_FACTORY_H_ */
