#ifndef SLICE_SAMPLER_H_
#define SLICE_SAMPLER_H_

#include <sampler/GibbsSampler.h>

class StochasticNode;

/**
 * Univariate slice sampler
 */
class SliceSampler : public GibbsSampler {
  double _width;
  long _nburn;
  double _sumdiff;
  long _iter, _maxwidth;
public:
  /**
   * Constructor for Slice Sampler
   * @param node Node to sample
   * @param width Initial width of slice
   * @param maxwidth Maximal width of slice as a multiple of the width
   * parameter
   * @param nburn Length of burnin
   */
  SliceSampler(StochasticNode *node, double width=1, long nburn = 1000,
	       long maxwidth = 10);
  void update();
  static bool canSample(StochasticNode const *node);
};

#endif /* SLICE_SAMPLER_H_ */
